/*
 *  fileio.c: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "error.h"
#include "unbind.h"


bind_s* read_Xfile(char* file)
{
  FILE* fp;
  long  size;
  bind_s* bp = NULL;

  if (fp = fopen(file, "rb")) {
    size = filelength(fileno(fp));
    if (size && size != -1L && (size&1L) == 0) {
      if (bp = (bind_s*)malloc(sizeof(bind_s)+BTAB_SIZ+size)) {
        memset(bp, 0, sizeof(bind_s)+BTAB_SIZ);
        bp->size = size;
        bp->btab = (dosdir_s*)(bp + 1);
        bp->body = (uchar*)bp + (sizeof(bind_s)+BTAB_SIZ);

        /* t@Cǂݍ */
        if (f_verbose) {
#ifdef	JMSG
          fprintf(stderr, "t@C %-12s ǂݍݒ... ", file);
#else
          fprintf(stderr, "reading file %-12s... ", file);
#endif
          fflush(stderr);
        }
        if (fread(bp->body, 1, bp->size, fp) == bp->size) {
          if (isXfile(bp->body)) {
            /* btab ̍쐬 */
            if (pathname2dosname(file, bp->btab)) {
              *(ulong*)&bp->btab->time =
#ifdef	HUMAN68K
                xlong(_dos_filedate(fileno(fp), 0));
#else
                ;/*FIX ME*/
#endif
              bp->btab->attr =
#ifdef	HUMAN68K
                _dos_chmod(file, -1);
#else
                ;/*FIX ME*/
#endif
            }
            else {
#ifdef	JMSG
              fatal("pX %s sł", file);
#else
              fatal("illegal path name %s", file);
#endif
            }
          }
          else {
#ifdef	JMSG
            fatal("t@C %s  .X `ł͂Ȃ悤ł", file);
#else
            fatal("file %s may be not .X", file);
#endif
          }
        }
        else {
#ifdef	JMSG
          fatal("t@C %s ̓ǂݍݒɃG[N܂", file);
#else
          fatal("read error at reading file %s", file);
#endif
        }
        if (f_verbose) {
#ifdef	JMSG
          fputs("I\n", stderr);
#else
          fputs("done\n", stderr);
#endif
        }
      }
      else {
#ifdef	JMSG
        fatal("t@C %s ǂݍރmۂł܂", file);
#else
        fatal("memory exhaust at reading file %s", file);
#endif
      }
    }
    else {
#ifdef	JMSG
      fatal("t@C %s ̃TCY(%ld)sł", file, size);
#else
      fatal("illegal size(%ld) of file %s", size, file);
#endif
    }
    fclose(fp);
  }
  else {
#ifdef	JMSG
    fatal("t@C %s I[vł܂", file);
#else
    fatal("can\'t open file %s", file);
#endif
  }
  return bp;
}


int split_Bfile(bind_s* base)
{
  int  cnt;
  ulong   ofs, siz;
  uchar*    mp;
  bind_s*   bp;
  dosdir_s* dp;

  /* oCht@Cǂ */
  if (!(ofs = isBfile(base->body))) return -1;

  /* oChe[u邩ǂ */
  if ((long)(siz = base->size - ofs) <= 0L) return -1;

  /* oChe[ũTCY */
  if (siz % BTAB_SIZ) return -1;

  /* oChꂽt@Cooɂ */
  cnt = siz / BTAB_SIZ;
  bp  = base;
  mp  = base->body;
  dp  = (dosdir_s*)((uchar*)base->body + ofs);

  while (cnt-- > 0) {
    bp->size = (cnt ? (dp+1)->size : ofs) - dp->size;
    bp->btab = dp++;
    bp->body = mp;
    mp += bp->size;
    if (cnt) {
      if ((bp->next = (bind_s*)malloc(sizeof(bind_s*))) == NULL) {
#ifdef	JMSG
        fatal("oCht@C𕪊邽߂̃obt@mۂł܂");
#else
        fatal("memory exhaust at splitting bindfile");
#endif
      }
      memset(bp->next, 0, sizeof(bind_s));
      bp = bp->next;
    }
  }

  return 0;
}


bind_s* read_Bfile(char* file)
{
  bind_s* bp;

  if (bp = read_Xfile(file)) {
    if (split_Bfile(bp) == -1) {
      if (f_check) return NULL;
#ifdef	JMSG
      fatal("t@C %s ̓oChĂȂ悤ł", file);
#else
      fatal("file %s is not BIND file", file);
#endif
    }
    bp->type = 1;	/* BIND file marker */
  }
  return bp;
}


void write_Bfile(bind_s* root, char* file)
{
  ulong ofs;
  bind_s* bp;
  FILE*   fp;
  char*   module;

  for (ofs = 0UL, bp = root; bp; bp = bp->next) {
    btab_ofs(bp->body) = 0L;
    if (f_secret) {
      bp->btab->fatno = (my_endian ? xshort(BTAB_ATR) : BTAB_ATR);
    }
    bp->btab->size = (my_endian ? xlong(ofs) : ofs);
    ofs += bp->size;
  }
  btab_ofs(root->body) = (my_endian ? xlong(ofs) : ofs);

  if (fp = fopen(file, "wb")) {
    if (f_verbose) {
#ifdef	JMSG
      fprintf(stderr, "t@C %-12s o... ", bindfile);
#else
      fprintf(stderr, "writing file %-12s... ", bindfile);
#endif
      fflush(stderr);
    }
    for (bp = root; bp; bp = bp->next) {
      if (fwrite(bp->body, 1, bp->size, fp) != bp->size) {
        module = dosname2filename(bp->btab, NULL);
#ifdef	JMSG
        fatal("W[ %s ݂̏Ɏs܂", module);
#else
        fatal("write error at module %s", module);
#endif
      }
    }
    for (bp = root; bp; bp = bp->next) {
      if (fwrite(bp->btab, 1, BTAB_SIZ, fp) != BTAB_SIZ) {
        module = dosname2filename(bp->btab, NULL);
#ifdef	JMSG
        fatal("W[ %s ̃e[u݂Ɏs܂", module);
#else
        fatal("write error at module table %s", module);
#endif
      }
    }
    if (f_verbose) {
#ifdef	JMSG
      fputs("I\n", stderr);
#else
      fputs("done\n", stderr);
#endif
    }
    fclose(fp);
  }
  else {
#ifdef	JMSG
    fatal("t@C %s 쐬ł܂", file);
#else
    fatal("cannot create file %s", file);
#endif
  }
}


