/*
 *  filename.c: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include <ctype.h>
#include "unbind.h"


dosdir_s* filename2dosname(const char* file, dosdir_s* dp)
{
  int   flen, elen;
  char* ext;
  static dosdir_s buf;

  if (dp == NULL) dp = &buf;

  flen = strlen(file);
  elen = 0;

  /* t@C擪 '.' XLbv */
  if (ext = STRRCHR(file+1, '.')) {
    elen = strlen(++ext);
    if (elen > 3) {
      /* gq */
      ext  = NULL;
      elen = 0;
    }
    else {
      /* '.' ̕␳ */
      flen -= elen + 1;
    }
  }

  /* t@C */
  if (flen > 18)  return NULL;

  /* t@Ci[̈ */
#if	1
  memset(dp->name1, ' ', 8+3);
#else
  memset(dp->name1, ' ', 8);
  memset(dp->ext,   ' ', 3);
#endif
  memset(dp->name2, 0, 10);

  if (flen > 8) {
    strncpy(dp->name1, file, 8);
    strncpy(dp->name2, file + 8, flen - 8);
  }
  else {
    strncpy(dp->name1, file, flen);
  }
  if (elen) {
    strncpy(dp->ext, ext, elen);
  }

  return dp;
}


dosdir_s* pathname2dosname(const char* path, dosdir_s* dp)
{
  char* ptr;

#if	defined(MSDOS) || defined(HUMAN68K)
  /* hCuXLbv */
  if (isalpha(*path) && path[1] == ':') {
    path += 2;
  }
  /* pXXLbv */
  if (ptr = STRRCHR(path, '\\')) {
    path = ++ptr;
  }
#endif

  /* pXXLbv */
  if (ptr = STRRCHR(path, '/')) {
    path = ++ptr;
  }

  return filename2dosname(path, dp);
}


char* dosname2filename(dosdir_s* dp, char* file)
{
  int   i;
  char* src;
  char* dst;
  static char buf[32];

  dst = file = (file ? file : buf);

  for (src = dp->name1, i = 0; i < 8; ++i) {
    if (*src == ' ') break;
    *dst++ = *src++;
  }

  /* TwentyOne Ή */
  if (i == 8) {
    for (src = dp->name2, i = 0; ++i <= 10; ) {
      if (*src == '\0') break;
      *dst++ = *src++;
    }
  }

  if (dp->ext[0] != ' ') {
    *dst++ = '.';
    for (src = dp->ext, i = 0; ++i <= 3; ) {
      if (*src == ' ') break;
      *dst++ = *src++;
    }
  }
  *dst = '\0';

  return file;
}


