/*
 *  module.c: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include <stdio.h>
#include <stdlib.h>
#include "unbind.h"


bind_s* search_module(bind_s* root, char* name)
{
  char    buf[32];
  bind_s* bp;

  if (root) {
    if (f_debug) {
      fprintf(stderr, "searching module %s... ", name);
      fflush(stderr);
    }
    for (bp = root; bp; bp = bp->next) {
      if (stricmp(dosname2filename(bp->btab, buf), name) == 0) {
        if (f_debug) fputs("found\n", stderr);
        return bp;
      }
    }
    if (f_debug) fputs("not found\n", stderr);
  }
  return NULL;
}


bind_s* delete_module(bind_s* root, char* name)
{
  char    buf[32];
  bind_s* bp;
  bind_s* prev;

  if (bp = search_module(root, name)) {
    if (bp == root) {
      return root->next;
    }
    for (prev = root, bp = root->next; bp; bp = bp->next) {
      if (stricmp(dosname2filename(bp->btab, buf), name) == 0) {
        prev->next = bp->next;
        free(bp);
        break;
      }
      prev = bp;
    }
    return root;
  }
  return NULL;
}


bind_s* append_module(bind_s* root, char* name)
{
  bind_s* bp;
  bind_s* prev;

  if ((bp = search_module(root, name)) == NULL) {
    if (bp = read_Xfile(name)) {
      if (root) {
        for (prev = root; prev; prev = prev->next) {
          if (prev->next == NULL) break;
        }
        prev->next = bp;
      }
      return bp;
    }
  }
  return NULL;
}


