#ifndef	_UNBIND_H_
#define	_UNBIND_H_	1
/*
 *  unbind.h: part of unbind for Human68k
 *  Copyright (C) 1997  oo<HGG00736@niftyserve.or.jp>
 */
#include "config.h"

#define	BTAB_OFS	(0x3c)
#define	BTAB_SIZ	(32)
#define	BTAB_ATR	(7)

#define	btab_ofs(/*uchar**/top)	(*(ulong*)((uchar*)top+BTAB_OFS))

#define	isXfile(/*uchar**/top)	(((uchar*)top)[0]=='H'&&((uchar*)top)[1]=='U')
#define	isBfile(/*uchar**/top)	(*(ulong*)((uchar*)top+BTAB_OFS))

typedef struct bind {
  int          type;
  size_t       size;
  struct bind* next;
  dosdir_s*    btab;
  uchar*       body;
}	bind_s;


extern int    my_endian;
extern char   tempfile[PATH_MAX];
extern char*  bindfile;
extern bind_s*bindroot;


extern int f_append;
extern int f_check;
extern int f_create;
extern int f_delete;
extern int f_list;
#if	0
extern int f_update;
#endif
extern int f_extract;

extern int f_all;
extern int f_debug;
extern int f_help;
extern int f_header;
extern int f_secret;
extern int f_verbose;
extern int f_version;


/* endian.c */
extern int endian(void);
extern unsigned short xshort(unsigned short s);
extern unsigned long  xlong(unsigned long l);
extern void xshortp(unsigned short* inptr, unsigned short* outptr);
extern void xlongp(unsigned long* inptr, unsigned long* outptr);

/* filename.c */
extern dosdir_s* filename2dosname(const char* file, dosdir_s* ptr);
extern dosdir_s* pathname2dosname(const char* path, dosdir_s* ptr);
extern char*     dosname2filename(dosdir_s* ptr, char* file);

/* fileio.c */
extern bind_s* read_Xfile(char* file);
extern bind_s* read_Bfile(char* file);
extern void    write_Bfile(bind_s* root, char* file);

/* module.c */
extern bind_s* search_module(bind_s* root, char* name);
extern bind_s* delete_module(bind_s* root, char* name);
extern bind_s* append_module(bind_s* root, char* name);

/* extract.c */
extern void extract(bind_s* root, int ac, char** av);

/* list.c */
extern void list(bind_s* root);

#endif	_UNBIND_H_
